(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: genr_vary.mli,v 1.11 2008/02/11 23:06:00 weis Exp $ *)

(** {3 Construction functions for generators with variable arity.} *)

val common_aux_functions : (Longident.t * Code.pattern list * Code.exp) list


val genr_function :
    Genr_base.function_definition ->
    Code.pattern ->
    (Longident.t * Code.pattern list * Code.exp) list * Code.exp

(** We treat the case of vary-adic generators.

    A vary-adic generator is associated to a unary constructors whose unique
    argument is a list that represents the variable length list of arguments
    of an associative binary operator (think of [+] as such a binary
    associative generator: we can ``flatten'' a comb of [+] applications into
    a unique application of [+] to the list of the combs' leaves).

    We generate a unary function for associative generators that are treated
    as vary-adic generators. *)
;;
