(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* useful functions and types *)

val bool_of_opt : 'a option -> bool;;

val value : 'a option -> 'a;;

module StrMap : Map.S with type key = string;;
module StrSet : Set.S with type elt = string;;

module IntMap : Map.S with type key = int;;
module IntSet : Set.S with type elt = int;;

type 'a bprint = Buffer.t -> 'a -> unit;;

module type ORD_PRT = sig
  type t;;
  val compare : t -> t -> int;;
  val bprint : t bprint;;
end;;

val new_line : 'a bprint -> 'a bprint;;

val bprint_pair : string -> 'a bprint -> ('a * 'a) bprint;;

type 'a fprint = out_channel -> 'a -> unit;;

val to_channel : 'a bprint -> 'a fprint;;
