(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: pr_otype.mli,v 1.25 2008/02/12 17:48:34 lowenthl Exp $ *)

(** {3 Printing Caml abstract syntax trees.} *)

open Parsetree
open Asttypes
;;

val is_infix : string -> bool
;;

val is_infix_longident : Longident.t -> bool
;;

val longident : Format.formatter -> Longident.t -> unit
;;

val blongident : Buffer.t -> Longident.t -> unit
;;

val infix_longident : Buffer.t -> Longident.t -> unit
;;

val core_type : Buffer.t -> core_type -> unit
;;

val pattern : Buffer.t -> pattern -> unit
;;

val value_description : Buffer.t -> value_description -> unit
;;

val find_text_in_file : Location.t -> string
;;

val verbatim : Buffer.t -> Location.t -> unit
;;

val verbatim_expression : Buffer.t -> expression -> unit
;;
val verbatim_pattern : Buffer.t -> pattern -> unit
;;
val verbatim_structure_item : Buffer.t -> structure_item -> unit
;;

val prefix_list :
  string -> (Buffer.t -> 'a -> unit) -> Buffer.t -> 'a list -> unit
;;

val list :
  string -> (Buffer.t -> 'a -> unit) -> Buffer.t -> 'a list -> unit
;;

val ptype : Buffer.t -> (string * type_declaration) -> unit
(** Prints in buffer the type defined in the type declaration. *)
;;

val type_declarations : Buffer.t -> (string * type_declaration) list -> unit
;;

val expression : Buffer.t -> expression -> unit
;;

val relation : Buffer.t -> relation -> unit
;;

val relations : Buffer.t -> relations -> unit
;;

val structure : Buffer.t -> structure_item list -> unit
;;
